//-------------------------------------------------------------------------------
//
//      spitter.h - Command line tool to process a file of 
//      Asterisk call "records". See Explanation () in
//      spitter.c.
//                         
//    Copyright (C) 2006  Mark D. Collier/Mark O'Brien
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//   Author: Mark D. Collier/Mark O'Brien - 08/07/2006  v1.0
//         www.securelogix.com - mark.collier@securelogix.com
//         www.hackingexposedvoip.com
//
//-------------------------------------------------------------------------------

#ifndef __SPITTER_H
#define __SPITTER_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <sys/time.h>
#include <unistd.h>

#include <signal.h>

//#include <time.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <fnmatch.h>

//#include <fcntl.h>

#define __SPITTER_VERSION  "spitter - Version 1.0"
#define __SPITTER_DATE     "          August 7, 2006"

int i;
int opt;

unsigned int verbosity                  = 0;
unsigned int numCallRecords             = 0;
unsigned int numLines                   = 0;
unsigned int numSPITCallsProvoked       = 0;

                                              // limit on concurrent spitter calls.
unsigned int limSpitterConcurrentCalls  = 0;  // 0 = unlimited.

long todSpitCallLimitReached            = 0;  // seconds relative to Epoch reference
long todSpitLastSaturationWarning       = 0;  //  seconds relative to Epoch reference

//  spitter saturation warnings will occur at this interval while the saturation condition persists. 

const long spitSaturationWarningPeriod  = 60 * 1; // seconds

int tempLimitSpitterConcurrentCalls     = 0;

int rc;

bool bLookingForBlankLine               = false;
bool bTestMode                          = false;
bool bPreExistingSpitterSaturation      = false;

char *psFileOfCallRecords       = NULL;

char line[2048];
char tmpFileName[2048];
char tmpFilePath[2048];
char outgoingFilePath[2048];

FILE *hFileOfCallRecords        = NULL;
FILE *hTmpFile                  = NULL;

struct stat statBuf;
    
struct timeval tv;

int   spitCallsAtLimit();
void  produceCallFileFromNextCallRec();
void  closeAndDropFile();

void  catch_signals(int signo);
void  CleanupAndExit( int status );
void  Explanation();
void  usage();

#endif  //  __SPITTER_H

/* EOF */
